package BPpackage;
 
/*
 * BoilerPlate.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.view.Gravity;
import android.view.View;
import android.view.inputmethod.InputMethodManager;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.TextView;
import android.widget.Toast;
import java.io.File;
import java.lang.Runnable;
import java.lang.String;
import java.util.ArrayList;
import java.util.List;

public class BoilerPlate extends Activity {

	public PRAFileHandler fhandler = new PRAFileHandler(this);

	public ImageButton Save;
	public ImageButton Cancel;
	public TextView title;
	public EditText editor;
	public InputMethodManager mgr;

	public String fname;

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		Save = (ImageButton) findViewById(R.id.btnSave);
		Cancel = (ImageButton) findViewById(R.id.btnCancel);
		editor = (EditText) findViewById(R.id.editor);
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_boilerplate);
		findViews();
		mgr = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);

		// fname is String "Some Name" => SomeName.txt
		fname = getIntent().getStringExtra("NAME");
		fname = fname.replaceAll("[^A-Za-z]", "");
		File sdCard = Environment.getExternalStorageDirectory();
		String app_dir = getResources().getString(R.string.app_name);
		String this_app_dir = sdCard.getAbsolutePath() +"/" + app_dir; 
		File dir = new File(this_app_dir);
		dir.mkdir();

		fname = this_app_dir +"/" + fname + ".txt"; 
		String content = fhandler.inputStreamToString(fname);
		if (content.matches("")){
			toaster(fname + " not found.\nCreating new file in "+ this_app_dir,
					Toast.LENGTH_LONG);
		}
		editor.setText(content);
	}


	public void save(View view) {
		toaster(getResources().getString(R.string.svannot), Toast.LENGTH_SHORT);
		final List<String> list = new ArrayList<String>();
		final String text = editor.getText().toString();
		String[] lines = text.split("\n");
		fhandler.writeArrayToExtFile(lines, fname);
		finish();
	}


	public void cancel(View view) {
		finish();
	}


	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

	
    public void showKbd(View view) {
		if(!(mgr==null)) mgr.showSoftInput(editor, InputMethodManager.SHOW_IMPLICIT);
    }

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed();
			return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}

}
