package BPpackage;
 
/*
 * PRAEula.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Runnable;

public class PRAEula extends Activity {

    public TextView title;
    public TextView eula;
	public Button accept;
	public Button decline;
	public Intent intent = new Intent();

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent orig = getIntent();
		String ver = orig.getStringExtra("VER");
		Context mActivity = getApplicationContext();
		setContentView(R.layout.activity_praeula);
		findViews();
		String msg = "Version " + ver + "\n\n"
				+ mActivity.getString(R.string.update) + "\n\n"
				+ mActivity.getString(R.string.eula);
		eula.setText(msg);
	}


	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		eula = (TextView) findViewById(R.id.eula);
		accept = (Button) findViewById(R.id.accept);
		decline = (Button) findViewById(R.id.decline);
	}


    public void accept(View view){
		setResult(RESULT_OK, intent);
		finish();
    }

    public void decline(View view){
		setResult(RESULT_CANCELED, intent);
		finish();
    }

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			setResult(RESULT_CANCELED, intent);
			finish();
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}

}
