package BPpackage;
 
/*
 * SearchAndReplace.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.text.InputType;
import android.view.Gravity;
import android.view.inputmethod.InputMethodManager;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Runnable;
import java.lang.String;

/**
 * SearchAndReplace.java created and copyrighted: Fri 04 Jul 2014 10:08:06 AM EDT
 * 
 * author: R. Earle Harris (richard.earle.harris@gmail.com)
 * 
 * The author releases this file under the GNU GPL license. See GNU's COPYING
 * file for specifics.
 **/

public class SearchAndReplace extends Activity {

	public PRAFileHandler fhandler = new PRAFileHandler(this);

	public Button Yes;
	public Button No;
	public Button Done;
	public Button Another;
	public TextView title;
	public TextView lreplace;
	public EditText editor;
	public InputMethodManager mgr;
	public String newTerm = "";
	public String oldTerm = "";
	public int index = 0;
	public int length = 0;

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		lreplace = (TextView) findViewById(R.id.lreplace);
		Yes = (Button) findViewById(R.id.byes);
		No = (Button) findViewById(R.id.bno);
		Another = (Button) findViewById(R.id.banother);
		Done = (Button) findViewById(R.id.bdone);
		editor = (EditText) findViewById(R.id.searchedit);
	}

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_searchandreplace);
		findViews();
		mgr = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
		//		mgr.hideSoftInputFromWindow(editor.getWindowToken(), 0);

		View v=this.getCurrentFocus();
		if(v !=null ){
			mgr.hideSoftInputFromWindow(v.getWindowToken(), InputMethodManager.HIDE_IMPLICIT_ONLY);
		}

		Intent intent = getIntent();
		String data = intent.getStringExtra("PAGE");
		editor.setText(data);
		setTerms();
	}

	private void setTerms(){
		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setContentView(R.layout.alert_two_twoedits);
		TextView t = (TextView) dialog.findViewById(R.id.dTitle);
		t.setText("Search and Replace");
		TextView m = (TextView) dialog.findViewById(R.id.dMessage);
		m.setText("Enter search term and replacement");
		final EditText e = (EditText) dialog.findViewById(R.id.dEdit);
		e.setInputType(InputType.TYPE_CLASS_TEXT);
		final EditText e2 = (EditText) dialog.findViewById(R.id.dEditTwo);
		e2.setInputType(InputType.TYPE_CLASS_TEXT);

		Button pos = (Button) dialog.findViewById(R.id.dPos);
		pos.setText("Start");
		pos.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				oldTerm = e.getText().toString();   
				length = oldTerm.length();
				newTerm = e2.getText().toString();   
				dialog.dismiss();
				toaster("Hide keyboard, if necessary.", Toast.LENGTH_SHORT);			
				next();
			}
			});
		
		Button neg = (Button) dialog.findViewById(R.id.dNeg);
		neg.setText("Cancel");
		neg.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				dialog.dismiss();
				toaster("Hide keyboard, if necessary.", Toast.LENGTH_SHORT);
			}
			});
		
		dialog.show();

    }


	public void yes(View view) {
		String content = editor.getText().toString();
		String toChange = content.substring(index);
		String tmp = toChange;
		toChange = toChange.replaceFirst(oldTerm, newTerm);
		content = content.replace(tmp, toChange);
		tmp = null;
		toChange = null;
		editor.setText(content);
		editor.setSelection(index, index);		
		index++;
		next();
	}

	public void no(View view) {
		index++;
		next();
	}

	public void done(View view) {
		doDone();
	}

	public void another(View view) {
		editor.setSelection(0,0);		
		setTerms();
	}

	private void next(){
		String content = editor.getText().toString();
		index = content.indexOf(oldTerm, index);
		if (index == -1){
			index = 0;
			length = 0;
			toaster("Returning to beginning of file", Toast.LENGTH_SHORT);
		}
		editor.setSelection(index, index + length);
	}

	private void doDone(){
		String text = editor.getText().toString();
		Intent intent = new Intent();
		intent.putExtra("PAGE", text);
		setResult(RESULT_OK, intent); 
		finish();
	}


    // length gets Toast.LENGTH_LONG|SHORT
	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

	
    public void showKbd(View view) {
		if(!(mgr==null)) mgr.showSoftInput(editor, InputMethodManager.HIDE_IMPLICIT_ONLY);
    }

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed();
			return;
		}
		doubleBackPressedOnce = true;
		doDone();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}

}
