package BPpackage;
 
/*
 * BoilerPlate.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.os.Environment;
import android.view.Gravity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ArrayAdapter;
import android.widget.TextView;
import android.widget.Toast;
import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class BoilerPlate extends ListActivity {

	public Map<String, String> dbs = new HashMap<String, String>();
	private ArrayList<String> selectedFiles = new ArrayList();
	public Intent i = new Intent();
	public String path = "";
	public String port = "";
	public String pswd = "";
	public String result = "";
	public String srvr = "";
	public String user = "";
	public boolean exit = false;
	public final static int CHS = 3;
	public final static int ElSE = 4;
	public int mode = -1;
	public String selected = " [x]";
	public File pwd = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_boilerplate);
		pwd = Environment.getExternalStorageDirectory();
		
	}

	/**
	 * call on resume when list is altered
	 **/
	@Override
	public void onResume() {
		super.onResume();

		final FileChooser c = this;
		final String[] list = buildList();
		setListAdapter(new ArrayAdapter<String>(this,
				R.layout.pra_list_item, list));

		EdgeEffectListView listView = (EdgeEffectListView) getListView();
		listView.setTextFilterEnabled(true);

		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				String choice = ((TextView) view).getText().toString();
				boolean sel = false;
				if (choice.endsWith(selected)){
					choice = choice.replace(selected, "");
					sel = true;
				} 
				String result = dbs.get(choice);
				File tmp = new File(result);
				if (tmp.isFile()){
					selectedFiles.clear();
					if (!sel){
						selectedFiles.add(result);
					}
				} else {
					pwd = tmp;
				}
				c.onResume();
			}
			});


		listView.setOnItemLongClickListener(new OnItemLongClickListener() {
		 
		    @Override 
			public boolean onItemLongClick(AdapterView parentView, View view, int position, long id) {
				String choice = ((TextView) view).getText().toString();
				boolean sel = false;
				if (choice.endsWith(selected)){
					choice = choice.replace(selected, "");
				}
				String result = dbs.get(choice);
				File tmp = new File(result);
				if (tmp.isDirectory()){
					if (sel){
						selectedFiles.remove(result);
					} else {
						selectedFiles.add(result);
					}
					c.onResume();
				} 

				return true;
			}
			});


	}

	public void done(View view){
		Intent intent = new Intent();
		intent.putExtra("FILE", selectedFiles);
		setResult(RESULT_OK, intent); 
		finish();
	}

	private String[] buildList() {
		List<String> alist = new ArrayList<String>();
		File[] flist = null;
		flist = pwd.listFiles();
		if (flist == null){
			File parent = pwd.getParentFile();
			if (parent != null){
				alist.add("..");
				dbs.put("..", parent.getPath());
			}
			toaster("ACCESS DENIED", Toast.LENGTH_SHORT);
			String[] list = new String[alist.size()];
			alist.toArray(list);
			return list;
		} else {
			for (File f : flist) {
				String name = f.getName();
				String path = f.getPath();
				if (f.isDirectory() ){
					name = name + "/";
				} 
				if (selectedFiles.contains(path)){
					name = name + selected;
				}
				alist.add(name);
				dbs.put(name, path);
			}
			
			File parent = pwd.getParentFile();
			if (parent != null){
				alist.add("..");
				dbs.put("..", parent.getPath());
			}
			
			Collections.sort(alist);
			String[] list = new String[alist.size()];
			alist.toArray(list);
			return list;
		}
	}
		

	@Override
	public void onBackPressed() {
		Intent intent = new Intent();
		setResult(RESULT_CANCELED, intent);
		finish();
	}

    // length gets Toast.LENGTH_LONG|SHORT
	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

}
