package BPpackage;
 
/*
 * Study.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */


import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.os.Handler;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View.OnTouchListener;
import android.view.View;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import java.lang.Integer;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class Study extends Activity implements OnTouchListener {

	public PRAFileHandler fhandler = new PRAFileHandler(this);

	public WebView wv;
	public TextView title;
	public Button nextBtn;
	public Button prevBtn;
	public String sides;
	public String[] cards;
	public WebViewClient client;

	public String[] currentCard = { "", "", "", "" };
	public String[] sizes;
	public boolean[] answer = { false, false, false, false };
	public boolean[] query = { false, false, false, false };
	public int which = 0;
	public int length = 0;
	public int count = 1;
	public String field_0 = "";
	public String field_1 = "";
	public String field_2 = "";
	public String field_3 = "";
	public String onError = "";
	public String deck;
	public String record;
	public String set;
	public boolean isAnswer = false;
	public int fields;
    public int simpleField;
	public boolean ruzhe = false;

	public String head = "<html><head><meta charset=\"utf-8\"></head>"
			+ "<body bgcolor=000 link=fff alink=fff vlink=fff >"
			+ "<center>" + "<style type=text/css>"
			+ "div.field_0{color: f90; font-size: $SZ0px; margin-top: 32px;}"
			+ "div.field_1{color: 3c3; font-size: $SZ1px;}"
			+ "div.field_2{color: 3c3; font-size: $SZ2px;}"
			+ "div.field_3{color: 3c3; font-size: $SZ3px;}</style>";
	public String page = "<div class=\"field_0\">$0</div>"
			+ "<div class=\"field_1\"><br>$1</div>"
			+ "<div class=\"field_2\"><br>$2</div>"
			+ "<div class=\"field_3\"><br>$3</div>";
	public String compounds = "<p><a href=\"http://www.xiaoma.info/compound.php?cp=$4\">Compounds</a>";
	public String close = "<h2>&nbsp;</h2></body></html>";

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent origin = this.getIntent();
		String appname = getResources().getString(R.string.app_name);
		if (appname.startsWith("Ruzhe")){
			ruzhe = true;
			simpleField = 0;
		} else {
			simpleField = simpleIndex(appname);
		}
		deck = origin.getStringExtra("DECK");
		set = origin.getStringExtra("SET");
		if (!ruzhe){
			String[] tokens = deck.split("/");
			String fname = tokens[tokens.length -1];
			fname = fname.replace(".txt", "");
			fname = fname.replace("_", " ");
			fname = fname.substring(0,1).toUpperCase() + fname.substring(1);
			deck = fname;
		}

		// deck normal, set ruzhe
		if ((deck.matches("last_test.txt")) || 
			((set != null) && (set.matches("last_test.txt")))){
			deck = "Last Test";
			set = "";
		}
		record = deck+" "+set;
		sides = origin.getStringExtra("SIDES");
		setSides();
		cards = origin.getStringArrayExtra("CARDS");
		length = cards.length;
		String tmp = origin.getStringExtra("SIZES");
		while (tmp.contains("\t\t")){
			tmp = tmp.replace("\t\t", "\t");
		}
		sizes = tmp.split("\t");
		setSizes();
		setContentView(R.layout.activity_study);
		findViews();
		nextBtn.setBackgroundResource(R.drawable.next);
		prevBtn.setBackgroundResource(R.drawable.prev);
		setProgress();
		wv.setOnTouchListener(this);
		wv.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);

		client = new WebViewClient() {
			@Override
			public boolean shouldOverrideUrlLoading(WebView view, String url) {
				// android error-page override
				wv.setWebViewClient(new WebViewClient() {
					public void onReceivedError(WebView view, int errorCode,
							String description, String failingUrl) {
						// TODO generalize this for on-line
						view.loadData(onError, "text/html;charset=utf-8", "utf-8");
					}
				});

				if (isOnline()) {
					wv.loadUrl(url);
					return true;
				} else {
					return false;
				}
			}
		};

		wv.setWebViewClient(client);
		wv.getSettings().setDefaultTextEncodingName("utf-8");

		Collections.shuffle(Arrays.asList(cards));
		showQuery(which);
	}

	private Integer simpleIndex(String appname){
		Map<String, Integer> map = new HashMap<String, Integer>();
		map.put("Chengyu Juju", new Integer(1));
		map.put("Guoyu Juju", new Integer(1));
		map.put("Hanzi Juju", new Integer(0));
		map.put("Lishi Juju", new Integer(1));
		map.put("Tangshi Juju", new Integer(1));
		map.put("Wenhua Juju", new Integer(0));
		map.put("Wuxia Juju", new Integer(0));
		map.put("Youxia Juju", new Integer(0));
		Integer result = map.get(appname);
		if (result == null){ 
			return -1; 
		} else {
			return result.intValue();
		}
	}

	public boolean isOnline() {
		ConnectivityManager cm = (ConnectivityManager) getBaseContext()
				.getSystemService(Context.CONNECTIVITY_SERVICE);

		NetworkInfo i = cm.getActiveNetworkInfo();
		if ((i == null) || (!i.isConnected())) {
			Toast toast = Toast.makeText(getBaseContext(),
					"Error: No connection to Internet", Toast.LENGTH_SHORT);
			toast.setGravity(Gravity.TOP | Gravity.CENTER, 0, 0);
			toast.show();
			return false;
		}
		return true;
	}
	
	public void setSizes(){
		head = head.replace("$SZ0", sizes[0]);
		head = head.replace("$SZ1", sizes[1]);
		if (sizes.length >= 3){
			head = head.replace("$SZ2", sizes[2]);
		}
		if (sizes.length == 4){
			head = head.replace("$SZ3", sizes[3]);
		}
	}

	public void setSides() {
		for (int i = 0; i < 4; i++) {
			// just the prompts on query
			if (sides.charAt(i) == 'q') {
				query[i] = true;
			}
			// everything on study mode answer
			if (sides.charAt(i) != 'x') {
				answer[i] = true;
			}
		}
	}

	public void showQuery(int which) {
		isAnswer = false;
		String tmp = cards[which];
		while (tmp.contains("\t\t")){
			tmp = tmp.replace("\t\t", "\t");
		}
		String[] tokens = tmp.split("\t");
		try {
			field_0 = tokens[0];
			field_1 = tokens[1];
			if ((ruzhe) && (field_1.trim().matches("-"))){
				field_1 = field_0;
			}
			field_2 = tokens[2];
			field_3 = tokens[3];
			if (ruzhe){
				field_3 = field_3.replace("_", " ");
			}
		} catch (Exception e) {
			// empty
		}
		String current = head;
		current = current + page;
		if (query[0]) {
			current = current.replace("$0", field_0);
		} else {
			current = current.replace("$0", "");
		}
		if (query[1]) {
			current = current.replace("$1", field_1);
		} else {
			current = current.replace("$1", "");
		}
		if (query[2]) {
			current = current.replace("$2", field_2);
		} else {
			current = current.replace("$2", "");
		}
		if (query[3]) {
			current = current.replace("$3", field_3);
		} else {
			current = current.replace("$3", "");
		}
		current = current + close;
		wv.loadData(current, "text/html;charset=utf-8", "utf-8");
		//		wv.reload();
		wv.clearHistory();
	}

	public void showAnswer() {
		isAnswer = true;
		String current = page;
		if (answer[0]) {
			if (simpleField == 0) {
				current = compounds + current;
				current = current.replace("$4", field_0);
			}
			current = current.replace("$0", field_0);
		} else {
			current = current.replace("$0", "");
		}
		if (answer[1]) {
			if (simpleField == 1) {
				current = compounds + current;
				current = current.replace("$4", field_1);
			}
			current = current.replace("$1", field_1);
		} else {
			current = current.replace("$1", "");
		}
		if (answer[2]) {
			current = current.replace("$2", field_2);
		} else {
			current = current.replace("$2", "");
		}
		if (answer[3]) {
			current = current.replace("$3", field_3);
		} else {
			current = current.replace("$3", "");
		}
		current = head + current + close;
		onError = current;
		wv.loadData(current, "text/html;charset=utf-8", "utf-8");
		//		wv.reload();
		wv.clearHistory();
	}

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
		wv = (WebView) findViewById(R.id.webview2);
		nextBtn = (Button) findViewById(R.id.next);
		prevBtn = (Button) findViewById(R.id.prev);
	}

	public void nextCard(View view) {
		count++;
		if (count > length){
			count = 1;
		}
		int i = which + 1;
		if (i == length) {
			Collections.shuffle(Arrays.asList(cards));
			i = 0;
		}
		which = i;
		setProgress();
		showQuery(which);
	}

	public void prevCard(View view) {
		count--;
		int i = which - 1;
		if (i < 0) {
			i = 0;
			count++;
		}
		which = i;
		setProgress();
		showQuery(which);
	}

	public void setProgress() {
		String hdr = deck+" "+set+": "+ Integer.toString(count) +"/"+ Integer.toString(length);
		title.setText(hdr);
	}


	/**
	 * TODO why do we need up and down both calling the method? Are we actually
	 * doing a click here?
	 */
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		if (v.getId() == R.id.webview2) {
			if (isAnswer) {
				return false;
			}
			switch (event.getAction()) {
			case MotionEvent.ACTION_DOWN:
				showAnswer();
				return false;
			case MotionEvent.ACTION_UP:
				showAnswer();
				return false;
			default:
				return false;
			}
		}
		return false;
	}

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if ((wv.canGoBack() == true) && (wv.getUrl().startsWith("http"))) {
			wv.goBack();
		} else {
			if (doubleBackPressedOnce) {
				/* memo
				List<String> top = Arrays.asList(record); 
				fhandler.writeToTopOfFile(top, "Memo.txt");
				*/
				super.onBackPressed();
				return;
			}
			doubleBackPressedOnce = true;
			Toast.makeText(this, R.string.exit2main, Toast.LENGTH_SHORT).show();
			new Handler().postDelayed(new Runnable() {

				@Override
				public void run() {
					doubleBackPressedOnce = false;
				}
			}, 2000);
		}
	}


    // length gets Toast.LENGTH_LONG|SHORT
	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

}
