#!/bin/bash
# pr_adb.sh
# created and copyrighted:  Mon 22 Jun 2015 07:59:46 AM CDT
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
fi

name=`cat $dot/name`
package=`cat $dot/package`

cd $PRIDE/$name
ADB=$ANDROID_HOME/platform-tools/adb
export ANDROID_LOG_TAGS="$name:D $package:D *:E SurfaceFlinger:S WindowStateAnimator:S PackageManager:F Watchdog:S WifiService:S"

skill -9 adb
$ADB start-server
$ADB shell setprop log.redirect-stdio true

DEVICES=`$ADB devices | awk '{ if ($0 ~ /device/ ){ ret = split($0, a, " ") }\
				{ if (ret == 2) {print a[1]}; ret = 0; }}'`

for d in $DEVICES; do
	$PRTERM -geometry 132x48 -e $ADB -s $d logcat &
	$ADB -s $d shell &
done
exit

