#!/bin/bash
# pr_newActivity.sh
# created and copyrighted:  4 May 13
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi

NONAMES="AudioService FileChooserLocal FTPJuju HelpScreen PRAEula SearchAndReplace x"

LIST=`ls -F $dot/plate/activity | grep / | tr -d /`
zenList "New Activity" "$LIST"

if [ "$CHOICE" == "Blank" ]; then
	pr_act$CHOICE.sh
else
	PLT=$dot/plate/activity/$CHOICE
	NONAME=`echo $NONAMES | awk 'BEGIN { RS = " " }; \
		{  if ( $0 ~ "'$CHOICE'" ) { print "yes"; exit } }'`

	setSrc

	if [ "$NONAME" != "yes" ]; then
		zenFormActivities
	else
		zenFormActivitiesNoName 
	fi

	parentImport
	XMLmanifest
	XMLvalues

	# res dirs
	DIRS=`ls $PLT/res`
	for d in $DIRS; do
		mkdir $PRIDE/$name/res/$d/
		cp $PLT/res/$d/* $PRIDE/$name/res/$d/
	done

	if [ "$NONAME" != "yes" ]; then
		rm $PRIDE/$name/res/layout/activity_boilerplate.xml
		cp $PLT/res/layout/activity_boilerplate.xml $PRIDE/$name/res/layout/activity_$tokenlc.xml
	fi

	# assets dir
	if [ -d $PLT/assets ]; then
		mkdir $PRIDE/$name/assets
		cp -r $PLT/assets/* $PRIDE/$name/assets
	fi

	# libs dir
	if [ -d $PLT/libs ]; then
		mkdir $PRIDE/$name/libs
		cp -L $PLT/libs/* $PRIDE/$name/libs/
	fi

	# src dir
	cp -rL $PLT/src/* $src/
	rm $src/4Parent.java 
	if [ "$NONAME" != "yes" ]; then
		mv $src/BoilerPlate.java $src/$token.java
	fi

	prReplace	
fi

