#!/bin/bash
# pr_newProject.sh
# created and copyrighted:  4 May 13
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi

#
# generate project with `android`
#
if [ "$1" == "" ]; then
	TARGETS=`ls $ANDROID_HOME/platforms`
    for t in $TARGETS; do
    	echo -n $t"|" >> prtmp;
        done;
    T=`cat prtmp`
    rm prtmp

    BITS=`zenity --forms --add-list=Target  --column-values=Targets --list-values="$T" --add-entry=Name --add-entry=Domain --title="New Project"`
    if [ "$BITS" == "" ]; then
    	exit
    fi

	BITS=`echo $BITS | tr -d ,`

	zenity --text="Creating Project" --progress --pulsate &
	ZEN=$!

    target=`echo $BITS | cut -d'|' -f1`
    T=`android list targets | grep "$target"`
    target=`echo $T | cut -d' ' -f2`

    name=`echo $BITS | cut -d'|' -f2 | tr -d ' '`
	if [ -d $PRIDE/$name ]; then
		exit
	fi
else
    name=$1
    target=1
	if [ -d $PRIDE/$name ]; then
		exit
	fi
    mkdirhier $PRIDE/$name
fi
path=$PRIDE/$name
if [ ! -d $PRIDE ]; then
	mkdir $PRIDE/
fi

package=`echo $BITS | cut -d'|' -f3`
if [ "$package" == "" ]; then
	package=`echo $DOMAIN"."$name | tr [:upper:] [:lower:]`;
else
	package=`echo $package"."$name | tr [:upper:] [:lower:]`
fi

android create project --target $target --name $name --path $path --activity $name --package $package || { zenity --warning --text="Project Not Added"; exit; }

echo $RELEASE_KEY1 >> $PRIDE/$name/ant.properties
echo $RELEASE_KEY2 >> $PRIDE/$name/ant.properties

echo $name > $PRIDE/$name/.name
echo $package > $PRIDE/$name/.package

#
# set project for pride
#
echo $name > ~/.pride/name
echo $package > ~/.pride/package


kill -HUP $ZEN
#
# plate injection
#
if [ "$PRIDEDEV" == "" ]; then
	true
else
    zenity --question --text="Inject pride project plate into $name"
fi
if [ $? -eq 0 ]; then
    pr_injectPlate.sh
fi

