#!/bin/bash
# pr_projectUpdate.sh
# created and copyrighted:  Fri May 31 09:42:16 EDT 2013
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi

name=`ls -F $PRIDE | grep / | tr -d / | zenity --list --height=400 --title "Update Shared Class" --column "Project" 2>/dev/null`
if [ "$name" == "" ]; then
	exit
fi

package=`cat $PRIDE/$name/.package`
path=`echo $package | tr \. /`
src=$PRIDE/$name/src/$path
SOURCE=`ls -1 $src | zenity --list --height=400 --title "Class to Update" --column "Classes"  2>/dev/null`
if [ "$SOURCE" == "" ]; then
	exit
fi

if [ -d $src/$SOURCE ]; then
	src=$src/$SOURCE 
	SOURCE=`ls -1 $src | zenity --list --height=400 --title "Class to Update" --column "Classes"  2>/dev/null`
	if [ "$SOURCE" == "" ]; then
		exit
	fi
fi

cd

DESTS=`find $PRIDE -name $SOURCE`
echo "---" >> $HOME/pr_updated.txt

for d in $DESTS; do
	echo $d >> $HOME/pr_updated.txt
	awk '{ if ( $0 !~ /^package/ ) { next } ; print $0 }' < $d > src_tmp
	cp $src/$SOURCE $d
	destpkg=`cat src_tmp | cut -d"." -f $DOMLEN | tr -d ";"` 
	origpkg=`echo $package | cut -d"." -f $DOMLEN`
	dest=`dirname $d`
	pr_sr.sh $dest $origpkg $destpkg
done

rm src_tmp
