#!/bin/bash
# pr_projectSeries.sh
# created and copyrighted:  14 aug 13
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
	source $dot/pride.src
fi

name=`ls -F $PRIDE | grep / | tr -d / | zenity --list --height=400 --title "Update Shared Class" --column "Project" 2>/dev/null`

if [ "$name" == "" ]; then
	exit
fi

package=`cat $PRIDE/$name/.package`
path=`echo $package | tr \. /`
src=$PRIDE/$name/src/$path
SOURCE=`zenity --entry --title="Update Series" --text "Class Prefix to Update"  2>/dev/null`

if [ "$SOURCE" == "" ]; then
	exit
fi

SRC=`find $src -name $SOURCE'??'.java`

if [ "$SRC" == "" ]; then
	exit
fi
#echo $SRC
cd
#ls

DESTS=`find $PRIDE -name $SOURCE'??'.java`

if [ "$DESTS" == "" ]; then
	exit
fi
#echo $DESTS
old=`head -n 1 $SRC | cut -d "." -f 3 | tr -d ";"`
#echo $old

echo "---" >> $HOME/pr_updated.txt

for d in $DESTS; do
	if [ "$d" == "$SRC" ]; then
		continue
	fi
#	echo "d: "$d
	echo $d >> $HOME/pr_updated.txt
	awk '{ if ( $0 !~ /^package/ ) { next } ; print $0 }' < $d > src_tmp
	awk '{ if ( $0 ~ /^package/ ) { next } ; print $0 }' < $SRC >> src_tmp
	pkg=`head -n 1 src_tmp | cut -d "." -f 3 | tr -d ";"`
#	echo $pkg
	dest=`dirname $d`
	mv src_tmp $d
	pr_sr.sh $dest $old $pkg
done

