#!/bin/bash
# pr_release.sh
# created and copyrighted:  4 May 13
#
# author: R. Earle Harris (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

if [ "$dot" == "" ]; then
	dot=$HOME/.pride
	source $dot/pride.rc
fi

name=`cat $dot/name`
package=`cat $dot/package`

cd $PRIDE/$name
$EDITOR ./AndroidManifest.xml
$EDITOR ./res/values/strings.xml

if [ "$PAUSEONEDIT" == "TRUE" ]; then
	echo "[ ENTER ] to continue"
	read
fi

ant clean release
cd bin

sleep 3

mkdir $RELEASES 2>/dev/null
mv $name-release.apk $RELEASES/$name.apk
rm $name-release*.apk

# personal
pride_personal.sh $name
# end personal

if [ "$VERSIONONRELEASE" == "TRUE" ]; then
	name2=`echo $name | sed s/[0-9]//g`
	version$name2.sh $name 2>/dev/null
fi

if [ "$BACKUPONRELEASE" == "TRUE" ]; then
	backupProject.sh $name 
fi

